package exercises

object Exercise1 extends App {
  def dup[A](r: List[Int], l: List[A]): List[A] = {
    r.zip(l).flatMap(p => {
      List.fill(p._1)(p._2)
    })
  }

  def removeDup[A](l: List[A]): List[A] = {
    l match {
      case head::tail => {
        head::removeDup(tail.filterNot(e => e == head))
      }
      case _ => l
    }
  }

  def zip[A, B](first: List[A], second: List[B]): List[(A, B)] = {
    first match {
      case head1::tail1 => {
        second match {
          case head2::tail2 => {
            (head1, head2)::zip(tail1, tail2)
          }
          case _ => Nil
        }
      }
      case _ => Nil
    }
  }

  def zipWith[A, B, C](xs: List[A], ys: List[B])(f: (A, B) => C): List[C] = {
    zip(xs, ys).map((p: (A, B)) => f(p._1, p._2))
  }
}